using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Collections.Generic;
using System.IO;
using System.Text;
using static System.Windows.Forms.LinkLabel;
using TIS.Imaging;
using OpenCvSharp;
using System.Linq;
//using OpenCvSharp.Extensions;

namespace Movable_Crosshairs
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
        private TIS.Imaging.OverlayBitmap _ob;
        private TIS.Imaging.OverlayBitmap _ob_Mark;
        private TIS.Imaging.OverlayBitmap _ob_AnglePosition;
        private GroupBox groupBox1;
        private System.Drawing.Point startPoint;
        private System.Drawing.Point middlePoint;
        private System.Drawing.Point endPoint;
        private int pointCount = 0;
        private Label labelCal;
        private Button buttonCSV;
        private bool isDragging = false;
        private System.Drawing.Point previousMousePosition;
        private System.Drawing.Point overlayPosition = new System.Drawing.Point(0, 0);
        private Button button_Judgement;
        private Button button_property;
        private Button button1;
        private TextBox txtMaxValue;
        private TextBox txtMinValue;
        private Label label3;
        private Label label1;
        private Label label_max;
        private Label label_min;
        private TextBox txtMaxAngle;
        private TextBox txtMinAngle;
        private System.Drawing.Point adjustStartPoint;
        private System.Drawing.Point adjustEndPoint;
        private FrameQueueSink _frameQueueSink;
        private Button button2;
        private Button button3;
        private Button button5;
        private Button button4;
        private Timer timer1;
        private Label label_MeanValue;
        private TextBox textBox1;
        private IContainer components;

        public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.label_MeanValue = new System.Windows.Forms.Label();
            this.button5 = new System.Windows.Forms.Button();
            this.button4 = new System.Windows.Forms.Button();
            this.button3 = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.txtMaxAngle = new System.Windows.Forms.TextBox();
            this.txtMinAngle = new System.Windows.Forms.TextBox();
            this.label_max = new System.Windows.Forms.Label();
            this.label_min = new System.Windows.Forms.Label();
            this.txtMaxValue = new System.Windows.Forms.TextBox();
            this.txtMinValue = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.button_property = new System.Windows.Forms.Button();
            this.button_Judgement = new System.Windows.Forms.Button();
            this.buttonCSV = new System.Windows.Forms.Button();
            this.labelCal = new System.Windows.Forms.Label();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // icImagingControl1
            // 
            this.icImagingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.icImagingControl1.AutoScroll = true;
            this.icImagingControl1.AutoScrollMinSize = new System.Drawing.Size(150, 150);
            this.icImagingControl1.BackColor = System.Drawing.Color.White;
            this.icImagingControl1.DeviceListChangedExecutionMode = TIS.Imaging.EventExecutionMode.Invoke;
            this.icImagingControl1.DeviceLostExecutionMode = TIS.Imaging.EventExecutionMode.AsyncInvoke;
            this.icImagingControl1.ImageAvailableExecutionMode = TIS.Imaging.EventExecutionMode.MultiThreaded;
            this.icImagingControl1.LiveDisplayPosition = new System.Drawing.Point(0, 0);
            this.icImagingControl1.Location = new System.Drawing.Point(12, 0);
            this.icImagingControl1.Name = "icImagingControl1";
            this.icImagingControl1.ScrollbarsEnabled = true;
            this.icImagingControl1.Size = new System.Drawing.Size(745, 751);
            this.icImagingControl1.TabIndex = 1;
            this.icImagingControl1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseDown);
            this.icImagingControl1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseMove);
            this.icImagingControl1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseUp);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.textBox1);
            this.groupBox1.Controls.Add(this.label_MeanValue);
            this.groupBox1.Controls.Add(this.button5);
            this.groupBox1.Controls.Add(this.button4);
            this.groupBox1.Controls.Add(this.button3);
            this.groupBox1.Controls.Add(this.button2);
            this.groupBox1.Controls.Add(this.txtMaxAngle);
            this.groupBox1.Controls.Add(this.txtMinAngle);
            this.groupBox1.Controls.Add(this.label_max);
            this.groupBox1.Controls.Add(this.label_min);
            this.groupBox1.Controls.Add(this.txtMaxValue);
            this.groupBox1.Controls.Add(this.txtMinValue);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.button1);
            this.groupBox1.Controls.Add(this.button_property);
            this.groupBox1.Controls.Add(this.button_Judgement);
            this.groupBox1.Controls.Add(this.buttonCSV);
            this.groupBox1.Controls.Add(this.labelCal);
            this.groupBox1.Dock = System.Windows.Forms.DockStyle.Right;
            this.groupBox1.Location = new System.Drawing.Point(532, 0);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(416, 751);
            this.groupBox1.TabIndex = 2;
            this.groupBox1.TabStop = false;
            // 
            // textBox1
            // 
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.textBox1.Font = new System.Drawing.Font("MS UI Gothic", 18F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.textBox1.Location = new System.Drawing.Point(0, 475);
            this.textBox1.Multiline = true;
            this.textBox1.Name = "textBox1";
            this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBox1.Size = new System.Drawing.Size(410, 275);
            this.textBox1.TabIndex = 26;
            // 
            // label_MeanValue
            // 
            this.label_MeanValue.AutoSize = true;
            this.label_MeanValue.Font = new System.Drawing.Font("MS UI Gothic", 36F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label_MeanValue.Location = new System.Drawing.Point(15, 15);
            this.label_MeanValue.Name = "label_MeanValue";
            this.label_MeanValue.Size = new System.Drawing.Size(135, 48);
            this.label_MeanValue.TabIndex = 25;
            this.label_MeanValue.Text = "label2";
            // 
            // button5
            // 
            this.button5.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button5.Location = new System.Drawing.Point(10, 259);
            this.button5.Name = "button5";
            this.button5.Size = new System.Drawing.Size(209, 38);
            this.button5.TabIndex = 24;
            this.button5.Text = "Aǂݎ~";
            this.button5.UseVisualStyleBackColor = true;
            this.button5.Click += new System.EventHandler(this.button5_Click);
            // 
            // button4
            // 
            this.button4.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button4.Location = new System.Drawing.Point(10, 209);
            this.button4.Name = "button4";
            this.button4.Size = new System.Drawing.Size(204, 44);
            this.button4.TabIndex = 23;
            this.button4.Text = "AǂݎJn";
            this.button4.UseVisualStyleBackColor = true;
            this.button4.Click += new System.EventHandler(this.button4_Click);
            // 
            // button3
            // 
            this.button3.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button3.Location = new System.Drawing.Point(12, 119);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(95, 43);
            this.button3.TabIndex = 22;
            this.button3.Text = "Jn";
            this.button3.UseVisualStyleBackColor = true;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // button2
            // 
            this.button2.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button2.Location = new System.Drawing.Point(119, 119);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(95, 43);
            this.button2.TabIndex = 21;
            this.button2.Text = "~";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // txtMaxAngle
            // 
            this.txtMaxAngle.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.txtMaxAngle.Location = new System.Drawing.Point(160, 441);
            this.txtMaxAngle.Name = "txtMaxAngle";
            this.txtMaxAngle.Size = new System.Drawing.Size(92, 28);
            this.txtMaxAngle.TabIndex = 20;
            this.txtMaxAngle.Text = "0";
            // 
            // txtMinAngle
            // 
            this.txtMinAngle.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.txtMinAngle.Location = new System.Drawing.Point(160, 356);
            this.txtMinAngle.Name = "txtMinAngle";
            this.txtMinAngle.Size = new System.Drawing.Size(92, 28);
            this.txtMinAngle.TabIndex = 19;
            this.txtMinAngle.Text = "0";
            // 
            // label_max
            // 
            this.label_max.AutoSize = true;
            this.label_max.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label_max.Location = new System.Drawing.Point(41, 444);
            this.label_max.Name = "label_max";
            this.label_max.Size = new System.Drawing.Size(105, 21);
            this.label_max.TabIndex = 18;
            this.label_max.Text = "I_pxF";
            // 
            // label_min
            // 
            this.label_min.AutoSize = true;
            this.label_min.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label_min.Location = new System.Drawing.Point(45, 359);
            this.label_min.Name = "label_min";
            this.label_min.Size = new System.Drawing.Size(105, 21);
            this.label_min.TabIndex = 17;
            this.label_min.Text = "n_pxF";
            // 
            // txtMaxValue
            // 
            this.txtMaxValue.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.txtMaxValue.Location = new System.Drawing.Point(160, 402);
            this.txtMaxValue.Name = "txtMaxValue";
            this.txtMaxValue.Size = new System.Drawing.Size(92, 28);
            this.txtMaxValue.TabIndex = 16;
            this.txtMaxValue.Text = "1000";
            // 
            // txtMinValue
            // 
            this.txtMinValue.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.txtMinValue.Location = new System.Drawing.Point(160, 318);
            this.txtMinValue.Name = "txtMinValue";
            this.txtMinValue.Size = new System.Drawing.Size(92, 28);
            this.txtMinValue.TabIndex = 15;
            this.txtMinValue.Text = "0";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label3.Location = new System.Drawing.Point(2, 405);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(148, 21);
            this.label3.TabIndex = 14;
            this.label3.Text = "[^[őlF";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label1.Location = new System.Drawing.Point(2, 322);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(148, 21);
            this.label1.TabIndex = 13;
            this.label1.Text = "[^[ŏlF";
            // 
            // button1
            // 
            this.button1.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button1.Location = new System.Drawing.Point(12, 70);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(95, 43);
            this.button1.TabIndex = 12;
            this.button1.Text = "foCX";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // button_property
            // 
            this.button_property.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button_property.Location = new System.Drawing.Point(119, 70);
            this.button_property.Name = "button_property";
            this.button_property.Size = new System.Drawing.Size(95, 43);
            this.button_property.TabIndex = 11;
            this.button_property.Text = "vpeB";
            this.button_property.UseVisualStyleBackColor = true;
            this.button_property.Click += new System.EventHandler(this.button_property_Click);
            // 
            // button_Judgement
            // 
            this.button_Judgement.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.button_Judgement.Location = new System.Drawing.Point(10, 168);
            this.button_Judgement.Name = "button_Judgement";
            this.button_Judgement.Size = new System.Drawing.Size(204, 35);
            this.button_Judgement.TabIndex = 10;
            this.button_Judgement.Text = "ǂݎ";
            this.button_Judgement.UseVisualStyleBackColor = true;
            this.button_Judgement.Click += new System.EventHandler(this.button_Judgement_Click);
            // 
            // buttonCSV
            // 
            this.buttonCSV.Font = new System.Drawing.Font("MS UI Gothic", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.buttonCSV.Location = new System.Drawing.Point(10, 492);
            this.buttonCSV.Name = "buttonCSV";
            this.buttonCSV.Size = new System.Drawing.Size(202, 39);
            this.buttonCSV.TabIndex = 9;
            this.buttonCSV.Text = "CSVt@CJ";
            this.buttonCSV.UseVisualStyleBackColor = true;
            this.buttonCSV.Click += new System.EventHandler(this.buttonCSV_Click);
            // 
            // labelCal
            // 
            this.labelCal.AutoSize = true;
            this.labelCal.Location = new System.Drawing.Point(25, 124);
            this.labelCal.Name = "labelCal";
            this.labelCal.Size = new System.Drawing.Size(0, 12);
            this.labelCal.TabIndex = 2;
            // 
            // timer1
            // 
            this.timer1.Interval = 500;
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(948, 751);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.icImagingControl1);
            this.MinimumSize = new System.Drawing.Size(344, 281);
            this.Name = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private List<Tuple<System.Drawing.Point, System.Drawing.Point>> lines = new List<Tuple<System.Drawing.Point, System.Drawing.Point>>();
        private Tuple<System.Drawing.Point, System.Drawing.Point> selectedLine = null;
        private bool isDraggingLine = false;

        private void Form1_Load(object sender, System.EventArgs e)
		{

            icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml");
            if ( !icImagingControl1.DeviceValid ) 
			{
				Close();
				return;
			}
            icImagingControl1.Sink = new TIS.Imaging.FrameSnapSink();

            timer1.Enabled = false;
            //icImagingControl1.LiveDisplay = false;
            //_frameQueueSink = new FrameQueueSink(Callback_FrameQueueSink, MediaSubtypes.RGB32, 5);
            //icImagingControl1.Sink = _frameQueueSink;

            icImagingControl1.LiveDisplayDefault = false;
            _ob = icImagingControl1.OverlayBitmapAtPath[TIS.Imaging.PathPositions.Device];
            _ob_Mark = icImagingControl1.OverlayBitmapAtPath[TIS.Imaging.PathPositions.Device];
            _ob_AnglePosition = icImagingControl1.OverlayBitmapAtPath[TIS.Imaging.PathPositions.Device];
            _ob.Enable = true;
            _ob_Mark.Enable = true;
            _ob_AnglePosition.Enable = true;
            icImagingControl1.DeviceTrigger = false;
            _ob.ColorMode = TIS.Imaging.OverlayColorModes.Color;
			icImagingControl1.LiveStart();
            //CtrlL[ƃ}EXzC[ŃY[AY[AEg̃Cxgnh
            this.icImagingControl1.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseWheel);
            this.MaximumSize = new System.Drawing.Size(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height);
            label_MeanValue.Text = "";
        }



        private int intZoom=10;
        //CtrlL[ƃ}EXzC[삵̏
        private void icImagingControl1_MouseWheel(object sender, MouseEventArgs e)
        {

            // CtrlL[ꂽԂł邩mF
            if ((Control.ModifierKeys & Keys.Control) == Keys.Control)
            {
                if (icImagingControl1.LiveDisplayDefault == false)
                {
                    // Y[{vZ
                    int value = e.Delta / 120;
                    intZoom += value;

                    // Y[{ŏ1{ȉɂȂȂ悤ɐ
                    if (intZoom < 1)
                    {
                        intZoom = 1;
                    }

                    // Y[{ݒ
                    icImagingControl1.LiveDisplayZoomFactor = (float)intZoom / 10.0f;
                }
            }

        }


        private bool IsPointOnLine(System.Drawing.Point p, System.Drawing.Point p1, System.Drawing.Point p2)
        {
            const int tolerance = 5;
            double distance = Math.Abs((p2.Y - p1.Y) * p.X - (p2.X - p1.X) * p.Y + p2.X * p1.Y - p2.Y * p1.X) / Math.Sqrt(Math.Pow(p2.Y - p1.Y, 2) + Math.Pow(p2.X - p1.X, 2));
            return distance < tolerance;
        }

        // }EXp̃tB[h
        private bool isDrawingCircle = false;
        private bool isDraggingCircle = false;
        private bool isResizingCircle = false;
        private System.Drawing.Point circleCenter;
        private int circleRadius = 100;
        private System.Drawing.Point dragStartPosition;
        // [^ݒp̃tB[h
        private double startAngle = 0; // [^Jnpx
        private double endAngle = 180; // [^Ipx
        private bool isSettingStartAngle = false;
        private bool isSettingEndAngle = false;

        private void icImagingControl1_MouseDown(object sender, MouseEventArgs e)
        {

            System.Drawing.Point clickPosition = e.Location;
            float zoomFactor = icImagingControl1.LiveDisplayZoomFactor;

            // NbNʒuY[{Œ
            int adjustedX = (int)(clickPosition.X / zoomFactor);
            int adjustedY = (int)(clickPosition.Y / zoomFactor);

            System.Drawing.Point adjustedClickPosition = new System.Drawing.Point(adjustedX, adjustedY);

            if (e.Button == MouseButtons.Right)
            {

                // [^̒S܂ĂꍇANbNʒupxvZ
                if (circleCenter != System.Drawing.Point.Empty)
                {

                    isSettingStartAngle=!isSettingStartAngle;
                    double angle = CalculateAngleFromCenter(adjustedClickPosition, circleCenter);

                    if (isSettingStartAngle)
                    {
                        _ob_AnglePosition.Fill(_ob_AnglePosition.DropOutColor);
                        startAngle = angle;
                        txtMinAngle.Text = startAngle.ToString();
                        adjustStartPoint = adjustedClickPosition;


                    }
                    else
                    {
                        endAngle = angle;

                        txtMaxAngle.Text = endAngle.ToString();
                        adjustEndPoint = adjustedClickPosition;
                    }
                    UpdateOverlay();
                }
            }


            if (e.Button == MouseButtons.Left)
            {
                // TCY[h: NbNʒu~t߂̏ꍇ
                if (IsPointOnCircleEdge(adjustedClickPosition, circleCenter, circleRadius))
                {
                    isResizingCircle = true;
                }
                // hbO[h: NbNʒu~̏ꍇ
                else if (IsPointInsideCircle(adjustedClickPosition, circleCenter, circleRadius))
                {
                    isDraggingCircle = true;
                    dragStartPosition = adjustedClickPosition;
                }
                else
                {
                    // V~̕`Jn
                    circleCenter = adjustedClickPosition;
                    circleRadius = 0;
                    isDrawingCircle = true;
                }
            }
        }

        // SNbNʒu܂ł̊pxvZ
        private double CalculateAngleFromCenter(System.Drawing.Point point, System.Drawing.Point center)
        {
            double deltaX = point.X - center.X;
            double deltaY = center.Y - point.Y; // YW͉摜Wnŏ㉺t

            // Atan2ŊpxvZiP: xj
            double angle = Math.Round(Math.Atan2(deltaY, deltaX) * (180.0 / Math.PI),2);

            // ^~̃gbv0xƂiItZbgǉj
            angle = 90 - angle;

            // px0-360͈̔͂ɒ
            return (angle >= 0) ? angle : angle + 360;
        }

        private void icImagingControl1_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left) return;

            System.Drawing.Point currentPosition = e.Location;
            float zoomFactor = icImagingControl1.LiveDisplayZoomFactor;

            // ݂̃}EXʒuY[{Œ
            int adjustedX = (int)(currentPosition.X / zoomFactor);
            int adjustedY = (int)(currentPosition.Y / zoomFactor);

            System.Drawing.Point adjustedCurrentPosition = new System.Drawing.Point(adjustedX, adjustedY);

            if (isDrawingCircle)
            {

                adjustStartPoint=new System.Drawing.Point();
                adjustEndPoint = new System.Drawing.Point(); 

                // avZ
                circleRadius = (int)Math.Sqrt(Math.Pow(adjustedCurrentPosition.X - circleCenter.X, 2) +
                                              Math.Pow(adjustedCurrentPosition.Y - circleCenter.Y, 2));

                // I[o[CXV
                UpdateOverlay();
            }
            else if (isDraggingCircle)
            {
                // hbOɂ~̒Sʒüړ
                int offsetX = adjustedCurrentPosition.X - dragStartPosition.X;
                int offsetY = adjustedCurrentPosition.Y - dragStartPosition.Y;
                if(adjustStartPoint!= new System.Drawing.Point(0, 0)) 
                { 
                    adjustStartPoint.X = adjustStartPoint.X + offsetX;
                    adjustStartPoint.Y = adjustStartPoint.Y + offsetY;
                }
                if (adjustEndPoint != new System.Drawing.Point(0, 0))
                { 
                    adjustEndPoint.X = adjustEndPoint.X + offsetX;
                    adjustEndPoint.Y = adjustEndPoint.Y + offsetY;
                }
                circleCenter = new System.Drawing.Point(circleCenter.X + offsetX, circleCenter.Y + offsetY);
                dragStartPosition = adjustedCurrentPosition;

                // I[o[CXV
                UpdateOverlay();
            }
            else if (isResizingCircle)
            {
                // TCY: VavZ
                circleRadius = (int)Math.Sqrt(Math.Pow(adjustedCurrentPosition.X - circleCenter.X, 2) +
                                              Math.Pow(adjustedCurrentPosition.Y - circleCenter.Y, 2));

                // I[o[CXV
                UpdateOverlay();
            }
        }

        private void icImagingControl1_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                isDrawingCircle = false;
                isDraggingCircle = false;
                isResizingCircle = false;
            }
        }

        // ~t߂NbNꂽ𔻒
        private bool IsPointOnCircleEdge(System.Drawing.Point point, System.Drawing.Point center, int radius, int tolerance = 5)
        {
            int dx = point.X - center.X;
            int dy = point.Y - center.Y;
            int distanceSquared = dx * dx + dy * dy;
            int radiusSquared = radius * radius;

            return Math.Abs(distanceSquared - radiusSquared) <= (tolerance * tolerance);
        }

        // ~̓NbNꂽ𔻒
        private bool IsPointInsideCircle(System.Drawing.Point point, System.Drawing.Point center, int radius)
        {
            int dx = point.X - center.X;
            int dy = point.Y - center.Y;
            return (dx * dx + dy * dy) <= (radius * radius);
        }

        // I[o[CXV
        private void UpdateOverlay()
        {
            _ob_Mark.Fill(_ob_Mark.DropOutColor); // O̕`NA
            _ob.Fill(_ob.DropOutColor); // O̕`NA
            _ob_AnglePosition.Fill(_ob_AnglePosition.DropOutColor);
            _ob.DrawFrameEllipse(System.Drawing.Color.Red, circleCenter.X - circleRadius, circleCenter.Y - circleRadius,
                circleCenter.X + circleRadius, circleCenter.Y + circleRadius);


            _ob_AnglePosition.DrawSolidEllipse(Color.Blue, adjustStartPoint.X - 20, adjustStartPoint.Y - 20, adjustStartPoint.X + 20, adjustStartPoint.Y + 20);
            _ob_AnglePosition.DrawSolidEllipse(Color.Blue, adjustEndPoint.X - 20, adjustEndPoint.Y - 20, adjustEndPoint.X + 20, adjustEndPoint.Y + 20);


        }




        private void button_Judgement_Click(object sender, EventArgs e)
        {
            _ob_AnglePosition.Fill(_ob_AnglePosition.DropOutColor);
            _ob_Mark.Fill(_ob_Mark.DropOutColor); // O̕`NA
            // Cu摜擾
            TIS.Imaging.FrameSnapSink snapSink = icImagingControl1.Sink as TIS.Imaging.FrameSnapSink;
            TIS.Imaging.IFrameQueueBuffer frm = snapSink.SnapSingle(TimeSpan.FromSeconds(5));
            CheckBrightnessOnCircle(circleCenter, circleRadius, frm); // m肵~̋PxmF
        }
        //񓯊̎s
        private FrameQueuedResult Callback_FrameQueueSink(IFrameQueueBuffer buffer)
        {
            _ob_AnglePosition.Fill(_ob_AnglePosition.DropOutColor);
            _ob_Mark.Fill(_ob_Mark.DropOutColor); // O̕`NA
            icImagingControl1.DisplayImageBuffer(buffer);
            CheckBrightnessOnCircle(circleCenter, circleRadius, buffer); // m肵~̋PxmF


            return FrameQueuedResult.ReQueue;
        }

        private void CheckBrightnessOnCircle(System.Drawing.Point center, int radius, TIS.Imaging.IFrameQueueBuffer buffer)
        {

            Bitmap liveImage = buffer.CreateBitmapCopy();
            if (liveImage == null)
            {
                MessageBox.Show("摜擾ł܂łB");
                return;
            }
            // WXg
            List<System.Drawing.Point> detectedPoints = new List<System.Drawing.Point>();

            // BitmapMatɕϊ
            Mat matImage = OpenCvSharp.Extensions.BitmapConverter.ToMat(liveImage);

            // O[XP[ϊ
            Mat grayImage = new Mat();
            Cv2.CvtColor(matImage, grayImage, ColorConversionCodes.BGR2GRAY);

            // l
            Mat binaryImage = new Mat();
            Cv2.Threshold(grayImage, binaryImage, 50, 255, ThresholdTypes.Binary);

            // GbWo
            Mat edges = new Mat();
            Cv2.Canny(binaryImage, edges,100, 255);
            Cv2.ImShow("edges", edges);
            // ubNoApxƐlvZ
            List<Tuple<double, double>> detectedAnglesAndValues = new List<Tuple<double, double>>();

            for (double angle = 0; angle < 360; angle += 1) // 1x݂ŌvZ
            {
                int x = (int)(center.X + radius * Math.Cos(angle * Math.PI / 180.0));
                int y = (int)(center.Y + radius * Math.Sin(angle * Math.PI / 180.0));

                // 摜͈͊O`FbN
                if (x < 0 || x >= edges.Width || y < 0 || y >= edges.Height)
                    continue;
                double topAlignedAngle = CalculateAngleFromCenter(new System.Drawing.Point(x, y), circleCenter);
                bool isEdgeDetected = false;
                // gbvACg̊pxJnpx菬ꍇ
                if (topAlignedAngle>@startAngle@|| topAlignedAngle < endAngle)
                { 
                // ӃsNZ肷
                
                    for (int offsetY = -2; offsetY <= 2; offsetY++) // c̋ߖT
                    {
                        for (int offsetX = -2; offsetX <= 2; offsetX++) // ̋ߖT
                        {
                            int neighborX = x + offsetX;
                            int neighborY = y + offsetY;

                            // ͈͊ÕsNZ͖
                            if (neighborX < 0 || neighborX >= edges.Width || neighborY < 0 || neighborY >= edges.Height)
                                continue;

                            // GbWoꂽꍇ
                            if (edges.At<byte>(neighborY, neighborX) == 255)
                            {
                                isEdgeDetected = true;
                                break;
                            }
                        }
                        if (isEdgeDetected) break;
                    }
                }
                // GbWoꂽꍇ̂ݏ𑱍s
                if (isEdgeDetected)
                {
                    
                    detectedPoints.Add(new System.Drawing.Point(x, y));

                    // pxlɕϊ
                    double value = MapAngleToValue(topAlignedAngle);
                    detectedAnglesAndValues.Add(new Tuple<double, double>(topAlignedAngle, value));
                }


                //Console.WriteLine(edges.At<byte>(y, x));
                //// ~̃GbWmF
                //if (edges.At<byte>(y, x) == 255) // GbWꍇ
                //{
                //    double topAlignedAngle = CalculateAngleFromCenter(new System.Drawing.Point(x, y), circleCenter);
                //    detectedPoints.Add(new System.Drawing.Point(x, y));
                //    // pxlɕϊ
                //    double value = MapAngleToValue(topAlignedAngle);

                //    detectedAnglesAndValues.Add(new Tuple<double, double>(topAlignedAngle, value));


                //}
            }
            UpdateOverlay();

            // ʂ\
            if (detectedAnglesAndValues.Count > 0)
            {
                // ϊpxƕϒlvZ
                double averageAngle = Math.Round(detectedAnglesAndValues.Average(item => item.Item1), 2);
                double averageValue = Math.Round(detectedAnglesAndValues.Average(item => item.Item2),2);

                int avgX = (int)detectedPoints.Average(point => point.X);
                int avgY = (int)detectedPoints.Average(point => point.Y);
                System.Drawing.Point averagePoint = new System.Drawing.Point(avgX, avgY);

                // ύWɖڈ`
                _ob_Mark.DrawSolidEllipse(Color.Green, avgX - 20, avgY - 20, avgX + 20, avgY + 20);
                label_MeanValue.Text= $"{averageValue.ToString()}g";

                // CSVɕۑ
                SaveToCsv(DateTime.Now, averageValue);

                // ListViewɗǉ
                AddToListView(DateTime.Now, averageValue,10);

                // ʃbZ[W\z
                string resultMessage = "oꂽpxƒl:\n";
                resultMessage += $"\nϊpx: {averageAngle:F2}";
                resultMessage += $"\nϒl: {averageValue:F2}";
                Console.WriteLine(resultMessage);


            }


        }


        // CSVɃf[^ۑ郁\bh
        private void SaveToCsv(DateTime timestamp, double averageValue)
        {
            string filePath = "results.csv";
            bool fileExists = File.Exists(filePath);

            using (StreamWriter writer = new StreamWriter(filePath, true))
            {
                if (!fileExists)
                {
                    // wb_[
                    writer.WriteLine("Date,Time,AverageValue");
                }

                // f[^
                writer.WriteLine($"{timestamp.ToShortDateString()},{timestamp.ToLongTimeString()},{averageValue:F2}");
            }
        }

        // ListViewɃf[^ǉ郁\bh
        private void AddToListView(DateTime timestamp, double averageValue, int maxLines = 10)
        {
            // VsƂăf[^쐬
            string newEntry = $"{timestamp.ToShortDateString()} {timestamp.ToLongTimeString()} {averageValue:F2}g";

            // ݂̃eLXgsPʂŕ
            string[] lines = textBox1.Lines;

            // ŐVsǉAÂs폜
            var updatedLines = lines.Append(newEntry).Skip(Math.Max(0, lines.Length + 1 - maxLines));

            // eLXg{bNXɍXVꂽeݒ
            textBox1.Lines = updatedLines.ToArray();

            // Ō̍sɃXN[
            textBox1.SelectionStart = textBox1.Text.Length;
            textBox1.ScrollToCaret();
        }

        private double GetMinValue()
        {
            return double.TryParse(txtMinValue.Text, out double minValue) ? minValue : 0; // ftHg0
        }

        private double GetMaxValue()
        {
            return double.TryParse(txtMaxValue.Text, out double maxValue) ? maxValue : 100; // ftHg100
        }

        private double GetMinAngle()
        {
            return double.TryParse(txtMinAngle.Text, out double startAngle) ? startAngle : 0; // ftHg0
        }

        private double GetMaxAngle()
        {
            return double.TryParse(txtMaxAngle.Text, out double EndAngle) ? EndAngle : 100; // ftHg100
        }


        // pxlɕϊwp[֐
        private double MapAngleToValue(double angle, double startAngle, double endAngle, double minValue, double maxValue)
        {
            return minValue + (angle - startAngle) * (maxValue - minValue) / (endAngle - startAngle);
        }


        // MapAngleToValue֐gpĒlvZ
        private double MapAngleToValue(double angle)
        {
            double minValue = GetMinValue();
            double maxValue = GetMaxValue();

            // 360lpx͈̔͌vZ
            double angleRange = (endAngle >= startAngle)
                ? endAngle - startAngle
                : 360 + endAngle - startAngle;

            double relativeAngle = (angle >= startAngle)
                ? angle - startAngle
                : 360 + angle - startAngle;

            // ľvZ
            return minValue + (relativeAngle / angleRange) * (maxValue - minValue);

        }


    

        private void buttonCSV_Click(object sender, EventArgs e)
        {
           
            // CSVt@C̃pXw
            string csvFilePath = "results.csv";

            // t@C݂邩mF
            if (!File.Exists(csvFilePath))
            {
                MessageBox.Show("CSVt@C݂܂Bf[^ۑĂ玎ĂB");
                return;
            }

            try
            {
                // NCSVJ
                System.Diagnostics.Process.Start("notepad.exe", csvFilePath);
            }
            catch (Exception ex)
            {
                MessageBox.Show($"CSVt@CJۂɃG[܂: {ex.Message}");
            }
           

        }

        private void button_property_Click(object sender, EventArgs e)
        {
            icImagingControl1.ShowPropertyDialog();
            icImagingControl1.SaveDeviceStateToFile("lastSelectedDeviceState.xml");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStop();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            icImagingControl1.LiveStart();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            _ob_AnglePosition.Fill(_ob_AnglePosition.DropOutColor);
            _ob_Mark.Fill(_ob_Mark.DropOutColor); // O̕`NA
            Cv2.WaitKey(100);
            // Cu摜擾
            TIS.Imaging.FrameSnapSink snapSink = icImagingControl1.Sink as TIS.Imaging.FrameSnapSink;
            TIS.Imaging.IFrameQueueBuffer frm = snapSink.SnapSingle(TimeSpan.FromSeconds(5));
            CheckBrightnessOnCircle(circleCenter, circleRadius, frm); // m肵~̋PxmF
        }

        private void button4_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;

        }

        private void button5_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }
    }
}
